package _static_help_methods;

import ronmodel.HLPlace;
import ronmodel.HLPlaceType;
import ronmodel.RON;
import ronmodel.Rule;

public class RuleIDManager {
	
	private static int nextID=0;
	
	/**
	 * @return next free ID
	 */
	public static int getNextID(){
		return nextID++;
	}
	
	/**
	 * Initializes the first ID.
	 * firstID:=(lowest rule-ID of the RON)+1
	 * 
	 * Must be called once after loading!
	 * 
	 */
	public static void initialize(RON ron){
		int lowestID=-1;
		if (ron!=null)
			for (Object o: ron.getNodes()){
				//for all nodes			
				if (o instanceof HLPlace){
					HLPlace p=(HLPlace)o;
					if (p.getType().getValue()==HLPlaceType.RULE){
						for (Object o1: p.getTokens()){
							lowestID=Math.max(lowestID, ((Rule)o1).getID());
						}
					}
				}
			}
		nextID=lowestID+1;
	}

}
