package _static_help_methods;

import ronmodel.HLPlace;
import ronmodel.RON;
import ronmodel.Token;

public class TokenName {
	
	/** 
	 * consistency check for given token-name
	 * @param name to check
	 * @param the ron to check (if ron==null => return false)
	 * @param mustBeUnique if true, only a unique name is allowed
	 * @return true if the name (is unique,) is not the empty string and is not null; otherwise false
	 */
	public static boolean isAllowedName(String name, RON ron, boolean mustBeUnique){
		//prohibit doubles, prohibit "(" (important for renaming of markers!!), prohibit empty-names	
		if (name==null || ron==null) return false;
		if (name.compareTo("")==0) return false;
		if (mustBeUnique)
			for (Object o: ron.getNodes()){			
				if (o instanceof HLPlace){
					//for all HLPlaces
					HLPlace p=(HLPlace)o;
					for (Object o1: p.getTokens()){
						//for all Tokens
						Token t1=(Token)o1;
						//if name already exists => return null
						if (t1.getName().compareTo(name)==0) return false;
					}
				}
			}
		return true;
	}

}
