package roneditor.commands;

import java.util.List;

import org.eclipse.gef.commands.Command;

import ronmodel.HLPlace;
import ronmodel.Token;

/**
 * @author conny
 * 
 * methode for adding a list of tokens to a HLPlace
 */

public class AddHLTokenCommand extends Command {
	private HLPlace place = null;

	private List<Token> tokens = null;

	public AddHLTokenCommand(HLPlace _place, List<Token> _tokens) {
		this.place = _place;
		this.tokens = _tokens;
	}

	@Override
	public boolean canExecute() {
		return true;
	}
	

	@Override
	public void execute() {
		this.place.getTokens().addAll(this.tokens);
	}

	@Override
	public void undo() {
		this.place.getTokens().removeAll(this.tokens);
	}
	
	public void redo(){
		execute();
	}
}
