/**
 * 
 */
package roneditor.commands;

import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.commands.Command;

import ronmodel.NamedElement;

public class MoveLabelCommand extends Command {
	private static final String Command_Label_Resize = 
		"Move Label Command";
	private Point newPosition;
	private Point oldPosition;
	
	private NamedElement node;
	
	public void execute() {
		oldPosition  = new Point(node.getLabelX(), node.getLabelY() );
		node.setLabelX(newPosition.x);
		node.setLabelY(newPosition.y);
	}
	
	public String getLabel(){
		return Command_Label_Resize;
	}
	
	public void redo() {
		node.setLabelX(newPosition.x);
		node.setLabelY(newPosition.y);
	}
	
	public void undo() {
		node.setLabelX(oldPosition.x);
		node.setLabelY(oldPosition.y);
	}

	/**
	 * @return the newPosition
	 */
	public Point getNewPosition() {
		return newPosition;
	}

	/**
	 * @param newPosition the newPosition to set
	 */
	public void setNewPosition(Point newPosition) {
		this.newPosition = newPosition;
	}

	/**
	 * @return the node
	 */
	public NamedElement getNode() {
		return node;
	}

	/**
	 * @param node the node to set
	 */
	public void setNode(NamedElement _node) {
		this.node = _node;
	}
}
