package roneditor.dialogs;

import org.eclipse.swt.SWT;
import org.eclipse.swt.SWTException;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import ronmodel.RON;
import _static_help_methods.TokenName;

import com.cloudgarden.resource.SWTResourceManager;

/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI
 * Builder, which is free for non-commercial use. If Jigloo is being used
 * commercially (ie, by a corporation, company or business for any purpose
 * whatever) then you should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details. Use of Jigloo implies
 * acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN
 * PURCHASED FOR THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR
 * ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
public class CreateHLPlaceOrTokenDialog extends org.eclipse.swt.widgets.Dialog {

	private Shell dialogShell;

	private Button ruleRadioButton;

	private Button cancelButton;

	private Button oKbutton;

	private Text nameText;

	private Label nameLabel;

	private Button netRadioButton;

	private boolean cancelled=true;

	private String nameTextValue;

	private boolean isNetType;
	
	private final RON ron;

	/**
	 * Auto-generated main method to display this org.eclipse.swt.widgets.Dialog
	 * inside a new Shell.
	 */
	public static void main(final String[] args) {
		try {
			final Display display = Display.getDefault();
			final Shell shell = new Shell(display);
			final CreateHLPlaceOrTokenDialog inst = new CreateHLPlaceOrTokenDialog(
					shell, SWT.NULL, null);
			inst.open();
		} catch (final Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * @param parent
	 * @param style
	 * @param ron ron of the node or token (for name-checking) or null if every name is allowed.
	 */
	public CreateHLPlaceOrTokenDialog(final Shell parent, final int style, RON ron) {
		super(parent, style);
		this.ron=ron;
	}

	public void open() {
		try {
			final Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM
					| SWT.APPLICATION_MODAL);
			final GridLayout dialogShellLayout = new GridLayout();
			dialogShellLayout.makeColumnsEqualWidth = true;
			dialogShellLayout.numColumns = 2;

			{
				// Register as a resource user - SWTResourceManager will
				// handle the obtaining and disposing of resources
				SWTResourceManager.registerResourceUser(dialogShell);
			}

			dialogShell.setLayout(dialogShellLayout);
			dialogShell.addKeyListener(new KeyAdapter() {
				@Override
				public void keyReleased(final KeyEvent evt) {
					keyEvent(evt);
				}				
				@Override
				public void keyPressed(final KeyEvent evt) {
					keyEvent(evt);
				}				
				
			});
			// START >> netRadioButton
			netRadioButton = new Button(dialogShell, SWT.RADIO | SWT.LEFT);
			netRadioButton.setText("NET");
			netRadioButton.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseUp(final MouseEvent evt) {
					netRadioButtonMouseUp(evt);
				}
			});
			// END << netRadioButton
			// START >> ruleRadioButton
			ruleRadioButton = new Button(dialogShell, SWT.RADIO | SWT.LEFT);
			ruleRadioButton.setText("RULE");
			ruleRadioButton.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseUp(final MouseEvent evt) {
					ruleRadioButtonMouseUp(evt);
				}
			});
			// END << ruleRadioButton
			// START >> nameLabel
			nameLabel = new Label(dialogShell, SWT.NONE);
			nameLabel.setText("Name:");
			// END << nameLabel
			// START >> nameText
			nameText = new Text(dialogShell, SWT.NONE);
			nameText.addKeyListener(new KeyAdapter() {
				@Override
				public void keyReleased(final KeyEvent evt) {
					keyEvent(evt);
				}
				@Override
				public void keyPressed(final KeyEvent evt) {
					keyEvent(evt);
				}
			});
			// END << nameText
			// START >> oKbutton
			oKbutton = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			oKbutton.setText("OK");
			nameCheck();
			oKbutton.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseUp(final MouseEvent evt) {
					oKbuttonMouseUp(evt);
				}
			});
			oKbutton.addKeyListener(new KeyAdapter() {
				@Override
				public void keyPressed(final KeyEvent evt) {
					if (evt.keyCode == 13 || evt.keyCode==32 /*(SPACE)*/) {						
						oKbuttonMouseUp(null);
					} else
					keyEvent(evt);
				}
				@Override
				public void keyReleased(final KeyEvent evt) {
					keyPressed(evt);
				}
			});
			// END << oKbutton
			// START >> cancelButton			
			cancelButton = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			cancelButton.setText("Cancel");			
			cancelButton.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseUp(final MouseEvent evt) {
					cancelButtonMouseUp(evt);
				}
			});
			cancelButton.addKeyListener(new KeyAdapter() {
				@Override
				public void keyPressed(final KeyEvent evt) {					
					if (evt.keyCode == 13 || evt.keyCode == SWT.ESC || evt.keyCode==32 /*(SPACE)*/) {
						cancelButtonMouseUp(null);
					}
				}
				@Override
				public void keyReleased(final KeyEvent evt) {
					keyPressed(evt);
				}
			});
			// END << cancelButton

			init();

			dialogShell.layout();
			dialogShell.pack();
			dialogShell.open();
			final Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch()) {
					display.sleep();
				}
			}
		} catch (final Exception e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * this mathod is called by KeyListeners
	 * @param evt KeyEvent
	 */
	private void keyEvent(final KeyEvent evt){
		enterOrESCKeyReleased(evt);
		nameCheck();					
	}

	/**
	 * Toggles the state of ok-button (isEnabled <=> name is allowed).
	 * If ron==null, every name is allowed (HLPlaces have no name-restriction).
	 */
	private void nameCheck(){
		try{
			if (ron==null) {
				oKbutton.setEnabled(true); //if ron==null - allow doubles
				return;
			}
			if (TokenName.isAllowedName(nameText.getText(),ron, true))
				oKbutton.setEnabled(true);
			else
				oKbutton.setEnabled(false);
		} catch (SWTException se){/*hack ;-)*/}
	}
	
	/**
	 * To be implemented by subclasses to initialize the Place or Token mode!
	 * Subclasses should call super.init() if ron!=null (name checking enabled)
	 */
	protected void init() {
		nameCheck();
	}

	protected Shell getDialogShell() {
		return dialogShell;
	}

	protected Button getRuleRadioButton() {
		return ruleRadioButton;
	}

	protected Button getNetRadioButton() {
		return netRadioButton;
	}

	protected Text getNameText() {
		return nameText;
	}

	private void oKbuttonMouseUp(@SuppressWarnings("unused")
	final MouseEvent evt) {
		// store data that can be retrived after widgets have been disposed
		if (oKbutton.isEnabled()){
			cancelled = false;
			nameTextValue = nameText.getText();
			isNetType = netRadioButton.getSelection();
			dialogShell.close();
		}
	}

	public String getNameTextValue() {
		return nameTextValue;
	}

	public boolean isNetType() {
		return isNetType;
	}

	private void cancelButtonMouseUp(@SuppressWarnings("unused")
	final MouseEvent evt) {
		cancelled = true;
		dialogShell.close();
	}
	
	private void enterOrESCKeyReleased(final KeyEvent evt) {
		if (evt.keyCode == 13) {
			oKbuttonMouseUp(null);
		}
		if (evt.keyCode == SWT.ESC) {
			cancelButtonMouseUp(null);
		}
	}

	public boolean isCancelled() {
		return cancelled;
	}

	private void netRadioButtonMouseUp(@SuppressWarnings("unused")
	final MouseEvent evt) {
		if (netRadioButton.isEnabled()) {
			netRadioButton.setSelection(true);
			ruleRadioButton.setSelection(false);
		}
	}

	private void ruleRadioButtonMouseUp(@SuppressWarnings("unused")
	final MouseEvent evt) {
		if (ruleRadioButton.isEnabled()) {
			ruleRadioButton.setSelection(true);
			netRadioButton.setSelection(false);
		}
	}
}
