package roneditor.dialogs.chooseRule;

import java.util.List;

import org.eclipse.core.runtime.Assert;
import org.eclipse.draw2d.ConnectionLayer;
import org.eclipse.gef.EditDomain;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.EditPartViewer;
import org.eclipse.gef.GraphicalViewer;
import org.eclipse.gef.LayerConstants;
import org.eclipse.gef.Tool;
import org.eclipse.gef.editparts.ScalableFreeformRootEditPart;
import org.eclipse.gef.tools.SelectionTool;
import org.eclipse.gef.ui.parts.ScrollingGraphicalViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.PlatformUI;

import ronmodel.ONTransition;
import ronmodel.Rule;

import com.cloudgarden.resource.SWTResourceManager;

/**
 * This code was edited or generated using CloudGarden's Jigloo
 * SWT/Swing GUI Builder, which is free for non-commercial
 * use. If Jigloo is being used commercially (ie, by a corporation,
 * company or business for any purpose whatever) then you
 * should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details.
 * Use of Jigloo implies acceptance of these licensing terms.
 * A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
 * THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
 * LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
/**
 * @author Tony Modica
 *
 */
public abstract class AbstractChooseRuleDialog extends Dialog {

	private EditDomain editDomain;

	private ScrollingGraphicalViewer viewerNAC, viewerLHS, viewerRHS;
	private Composite compositeNetMiddle;

	private int currentRulePos;

	private final List<Rule> rules;

	private boolean canceled = true;


	// visual stuff
	private Shell dialogShell;
	private Composite compositeApplyLower;
	private Button buttonCancel;
	private Button buttonOK;
	private Composite compositeViewerNAC,compositeViewerLHS,compositeViewerRHS;
	private Button buttonNextNet;
	private Button buttonPreviousNet;
	private Composite compositeNetUpper;

	public AbstractChooseRuleDialog(final List<Rule> rules) {
		super(new Shell(Display.getDefault()), SWT.NULL);
		Assert.isTrue(rules != null && !rules.isEmpty(),
				"ChooseRuleDialog requires at least one object net!");
		this.rules = rules;
	}

	/**
	 * Builds the dialog by creating the widget hierarchy and calling
	 * {@link #init()}.
	 *
	 * @see #init()
	 */
	public void open() {
		try {
			final Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM
					| SWT.APPLICATION_MODAL | SWT.RESIZE);

			{
				// Register as a resource user - SWTResourceManager will
				// handle the obtaining and disposing of resources
				SWTResourceManager.registerResourceUser(dialogShell);
			}

			final GridLayout dialogShellLayout = new GridLayout();
			dialogShellLayout.makeColumnsEqualWidth = true;
			dialogShell.setLayout(dialogShellLayout);

			dialogShell.setText("Select Rule");
			// START >> compositeNetUpper
			final GridData compositeNetUpperLData = new GridData();
			compositeNetUpperLData.horizontalAlignment = GridData.CENTER;
			compositeNetUpperLData.grabExcessHorizontalSpace = true;
			compositeNetUpper = new Composite(dialogShell, SWT.NONE);
			final GridLayout compositeNetUpperLayout = new GridLayout();
			compositeNetUpperLayout.numColumns = 2;
			compositeNetUpperLayout.makeColumnsEqualWidth = true;
			compositeNetUpper.setLayout(compositeNetUpperLayout);
			compositeNetUpper.setLayoutData(compositeNetUpperLData);
			{
				compositeNetMiddle = new Composite(dialogShell, SWT.NONE);
				GridLayout compositeNetMiddleLayout = new GridLayout();
				compositeNetMiddleLayout.numColumns = 3;
				compositeNetMiddleLayout.makeColumnsEqualWidth = false;
					final FillLayout compositeViewerLayout = new FillLayout(
						org.eclipse.swt.SWT.HORIZONTAL);
					GridData compositeViewerLData = new GridData();
					compositeViewerLData.grabExcessHorizontalSpace = true;
					compositeViewerLData.horizontalAlignment = GridData.FILL;
					compositeViewerLData.verticalAlignment = GridData.FILL;
					compositeViewerLData.grabExcessVerticalSpace = true;
					GridData compositeNetMiddleLData = new GridData();
					compositeNetMiddleLData.verticalAlignment = GridData.FILL;
					compositeNetMiddleLData.grabExcessVerticalSpace = true;
					compositeNetMiddleLData.grabExcessHorizontalSpace = true;
					compositeNetMiddleLData.horizontalAlignment = GridData.FILL;
					compositeNetMiddle.setLayoutData(compositeNetMiddleLData);
				compositeNetMiddle.setLayout(compositeNetMiddleLayout);
				{
					compositeViewerNAC = new Composite(
						compositeNetMiddle,
						SWT.NONE);
					compositeViewerNAC.setLayout(compositeViewerLayout);
					compositeViewerNAC.setLayoutData(compositeViewerLData);
				}
				{
					compositeViewerLHS = new Composite(
						compositeNetMiddle,
						SWT.NONE);
					compositeViewerLHS.setLayout(compositeViewerLayout);
					compositeViewerLHS.setLayoutData(compositeViewerLData);
				}
				{
					compositeViewerRHS = new Composite(
						compositeNetMiddle,
						SWT.NONE);
					compositeViewerRHS.setLayout(compositeViewerLayout);
					compositeViewerRHS.setLayoutData(compositeViewerLData);
				}
			}
			// START >> buttonPreviousNet
			buttonPreviousNet = new Button(compositeNetUpper, SWT.PUSH
					| SWT.CENTER);
			final GridData buttonPreviousNetLData = new GridData();
			buttonPreviousNetLData.horizontalAlignment = GridData.CENTER;
			buttonPreviousNet.setLayoutData(buttonPreviousNetLData);
			buttonPreviousNet.setText("Previous Rule");
			buttonPreviousNet.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseUp(final MouseEvent evt) {
					buttonPreviousNetMouseUp(evt);
				}
			});
			// END << buttonPreviousNet
			// START >> buttonNextNet
			buttonNextNet = new Button(compositeNetUpper, SWT.PUSH | SWT.CENTER);
			final GridData buttonNextNetLData = new GridData();
			buttonNextNetLData.horizontalAlignment = GridData.CENTER;
			buttonNextNet.setLayoutData(buttonNextNetLData);
			buttonNextNet.setText("Next Rule");
			buttonNextNet.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseUp(final MouseEvent evt) {
					buttonNextNetMouseUp(evt);
				}
			});
			// END << buttonNextNet
			// END << compositeNetUpper
			// START >> compositeViewer
			// END << compositeViewer
			// START >> compositeApplyLower
			compositeApplyLower = new Composite(dialogShell, SWT.NONE);
			final GridLayout compositeAppLayout = new GridLayout();
			compositeAppLayout.makeColumnsEqualWidth = true;
			compositeAppLayout.numColumns = 2;
			final GridData compositeApplyLowerLData = new GridData();
			compositeApplyLowerLData.horizontalAlignment = GridData.CENTER;
			compositeApplyLower.setLayoutData(compositeApplyLowerLData);
			compositeApplyLower.setLayout(compositeAppLayout);
			// START >> buttonFire
			buttonOK = new Button(compositeApplyLower, SWT.PUSH | SWT.CENTER);
			buttonOK.setText("OK");
			buttonOK.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseUp(final MouseEvent evt) {
					buttonFireMouseUp();
				}
			});
			// END << buttonFire
			// START >> buttonCancel
			buttonCancel = new Button(compositeApplyLower, SWT.PUSH
					| SWT.CENTER);
			final GridData buttonCancelLData = new GridData();
			buttonCancel.setLayoutData(buttonCancelLData);
			buttonCancel.setText("Cancel");
			buttonCancel.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseUp(final MouseEvent evt) {
					buttonCancelMouseUp();
				}
			});
			// END << buttonCancel
			// END << compositeApplyLower

			// set up the rest
			init();

			dialogShell.layout();
			dialogShell.pack();
			dialogShell.open();
			final Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch()) {
					display.sleep();
				}
			}
		} catch (final Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 *
	 */
	private void init() {
		createGraphicalViewer();
		setCurrentRule(0);
		
		buttonOK.setEnabled(true);

		// allow switching only if multiple objects are available
		buttonNextNet.setEnabled(rules.size() > 1);
		buttonPreviousNet.setEnabled(rules.size() > 1);
	}

	/**
	 * @return A newly created and configured {@link ScrollingGraphicalViewer}
	 *         on the sashForm.
	 *
	 * @see #getEditDomain()
	 * @see #getEditPartFactory()
	 */
	private void createGraphicalViewer() {
		// set the new viewer on the viewer composite
		viewerNAC = new ScrollingGraphicalViewer();
		viewerLHS = new ScrollingGraphicalViewer();
		viewerRHS = new ScrollingGraphicalViewer();
		viewerNAC.createControl(compositeViewerNAC);
		viewerNAC.setEditDomain(getEditDomain());
		viewerLHS.createControl(compositeViewerLHS);
		viewerLHS.setEditDomain(getEditDomain());
		viewerRHS.createControl(compositeViewerRHS);
		viewerRHS.setEditDomain(getEditDomain());
		getEditDomain().addViewer(viewerNAC);
		getEditDomain().addViewer(viewerLHS);		
		getEditDomain().addViewer(viewerRHS);
		final ScalableFreeformRootEditPart rootEditPartNAC = new ScalableFreeformRootEditPart();
		final ScalableFreeformRootEditPart rootEditPartLHS = new ScalableFreeformRootEditPart();
		final ScalableFreeformRootEditPart rootEditPartRHS = new ScalableFreeformRootEditPart();
		viewerNAC.setRootEditPart(rootEditPartNAC);
		viewerNAC.setEditPartFactory(getEditPartFactory());
		viewerLHS.setRootEditPart(rootEditPartLHS);
		viewerLHS.setEditPartFactory(getEditPartFactory());
		viewerRHS.setRootEditPart(rootEditPartRHS);
		viewerRHS.setEditPartFactory(getEditPartFactory());
		// set antialias on connection layer, this may be turned off if
		// causing trouble
		((ConnectionLayer) rootEditPartNAC
				.getLayer(LayerConstants.CONNECTION_LAYER))
				.setAntialias(SWT.ON);
		((ConnectionLayer) rootEditPartLHS
				.getLayer(LayerConstants.CONNECTION_LAYER))
				.setAntialias(SWT.ON);
		((ConnectionLayer) rootEditPartRHS
				.getLayer(LayerConstants.CONNECTION_LAYER))
				.setAntialias(SWT.ON);
		// some optional coloring
		viewerNAC.getControl().setBackground(
				PlatformUI.getWorkbench().getDisplay().getSystemColor(
						SWT.COLOR_LIST_BACKGROUND));
		viewerNAC.getControl().setForeground(
				PlatformUI.getWorkbench().getDisplay().getSystemColor(
						SWT.COLOR_LIST_FOREGROUND));
		viewerLHS.getControl().setBackground(
				PlatformUI.getWorkbench().getDisplay().getSystemColor(
						SWT.COLOR_LIST_BACKGROUND));
		viewerLHS.getControl().setForeground(
				PlatformUI.getWorkbench().getDisplay().getSystemColor(
						SWT.COLOR_LIST_FOREGROUND));
		viewerRHS.getControl().setBackground(
				PlatformUI.getWorkbench().getDisplay().getSystemColor(
						SWT.COLOR_LIST_BACKGROUND));
		viewerRHS.getControl().setForeground(
				PlatformUI.getWorkbench().getDisplay().getSystemColor(
						SWT.COLOR_LIST_FOREGROUND));
	}

	/**
	 * @return An lazily created {@link EditPartFactory} for the
	 *         {@link GraphicalViewer} created in
	 *         {@link #createGraphicalViewer()}.
	 */
	abstract protected EditPartFactory getEditPartFactory();

	/**
	 * @return A lazily created {@link EditDomain} that works on this dialog's
	 *         command stack with a {@link Tool} for creating Mappings as
	 *         default tool.
	 *
	 * @see #getCommandStack()
	 */
	private EditDomain getEditDomain() {
		if (null == editDomain) {
			editDomain = new EditDomain();
			editDomain.setDefaultTool(new SelectionTool() {
				/**
				 * Don't forward the event to the drag tracker as SelectionTool
				 * would do.
				 */
				@Override
				public void mouseDrag(final MouseEvent e,
						final EditPartViewer viewer) {
				}
			});
			editDomain.loadDefaultTool();
		}
		return editDomain;
	}

	/**
	 * @param objectNetPos
	 */
	private void setCurrentRule(final int rulePos) {
		currentRulePos = rulePos;
		final Rule rule = rules.get(rulePos);
		if (rule.getNacs().size() == 0) {
			viewerNAC.setContents(null);
		} else {
			viewerNAC.setContents(rule.getNacs().get(0));
		}
		viewerLHS.setContents(rule.getLhs());
		viewerRHS.setContents(rule.getRhs());
	}

	void buttonFireMouseUp() {
		canceled = false;
		closeDialog();
	}

	/**
	 * @param evt
	 */
	void buttonPreviousNetMouseUp(@SuppressWarnings("unused")
	final MouseEvent evt) {
		final int newRulePos = currentRulePos == 0 ? rules.size() - 1
				: currentRulePos - 1;
		setCurrentRule(newRulePos);
		

		dialogShell.pack();
	}

	/**
	 * @param evt
	 */
	void buttonNextNetMouseUp(@SuppressWarnings("unused")
	final MouseEvent evt) {
		final int newRulePos = currentRulePos == rules.size() - 1 ? 0
				: currentRulePos + 1;
		setCurrentRule(newRulePos);

		dialogShell.pack();
		
	}

	
//	private Dimension calculateNewSize(ObjectNet objNet) {
//		Integer maxH = 300;
//		Integer maxW = 300;
//		for (Object obj:objNet.getNodes()) {
//			ONNode onNode = (ONNode)obj;
//			// Width
//			if (onNode.getLabelX() > 0) {
//				if (onNode.getX()+onNode.getLabelX() + 50 > maxW) {
//					maxW = onNode.getX()+onNode.getLabelX() + 50;
//				}
//			} else {
//				if (onNode.getX() + 50 > maxW) {
//					maxW = onNode.getX() + 50;
//				}
//			}
//			// Height
//			if (onNode.getLabelY() > 0) {
//				if (onNode.getY()+onNode.getLabelY() + 50 > maxH) {
//					maxH = onNode.getY()+onNode.getLabelY() + 50;
//				}
//			} else {
//				if (onNode.getY() + 50 > maxH) {
//					maxH = onNode.getY() + 50;
//				}
//			}
//			
//		}
//		return new Dimension(maxW,maxH);
//	}
	
	
	/**
	 *
	 */
	void buttonCancelMouseUp() {
		closeDialog();
	}

	/**
	 *
	 */
	private void closeDialog() {
		dialogShell.close();
	}



	/**
	 * @return <code>true</code> if this dialog has been canceled.
	 */
	public boolean isCanceled() {
		return canceled;
	}

	public Rule getSelectedRule() {
		return rules.get(currentRulePos);
	}
	
	

	/**
	 * This method decides if a transition is activated. Subclasses should implement this to adapt the dialog to respect specific properties like weight and capacity of post places.
	 *
	 * @param transition The transition to test for activation
	 * @return Whether the transition is activated or not
	 */
	abstract protected boolean isActivated(ONTransition transition);

}
