package roneditor.objectnetview.commands;


import ronmodel.ONNode;
import ronmodel.ObjectNet;


/**
 * Command for creating a place.
 */
public class AbstractCreateONNodeCommand
	extends org.eclipse.gef.commands.Command
{
	protected ONNode onNode;
	protected int x;
	protected int y;
	protected int labelX;
	protected int labelY;
	protected ObjectNet objectNet;
	protected String name;
	
/**
 * Constructor.
 *
 */	
	public AbstractCreateONNodeCommand() {
		super();
	}
	
	/**
	 * Entry point for command execution.
	 */
	public void execute() {
		onNode.setName(name);
		onNode.setX(x);
		onNode.setY(y);
		onNode.setLabelX(labelX);
		onNode.setLabelY(labelY);
		onNode.setObjectNet(objectNet);
	}
	
	/**
	 * Redo command execution.
	 */
	public void redo() {
		onNode.setObjectNet(objectNet);
	}
	
	/**
	 * Undo command execution.
	 */
	public void undo() {
		onNode.setObjectNet(null);
	}

/**
 * @return the onPlace
 */
public ONNode getONNode() {
	return onNode;
}

/**
 * @param onPlace the onPlace to set
 */
public void setONNode(ONNode onNode) {
	this.onNode = onNode;
}

/**
 * @return the objectNet
 */
public ObjectNet getObjectNet() {
	return objectNet;
}

/**
 * @param objectNet the objectNet to set
 */
public void setObjectNet(ObjectNet objectNet) {
	this.objectNet = objectNet;
}

/**
 * @return the x
 */
public int getX() {
	return x;
}

/**
 * @param x the x to set
 */
public void setX(int x) {
	this.x = x;
}

/**
 * @return the y
 */
public int getY() {
	return y;
}

/**
 * @param y the y to set
 */
public void setY(int y) {
	this.y = y;
}

/**
 * @return the labelX
 */
public int getLabelX() {
	return labelX;
}

/**
 * @param x the x to set
 */
public void setLabelX(int labelX) {
	this.labelX = labelX;
}

/**
 * @return the labelY
 */
public int getLabelY() {
	return labelY;
}

/**
 * @param y the y to set
 */
public void setLabelY(int labelY) {
	this.labelY = labelY;
}


/**
 * @return the name
 */
public String getName() {
	return name;
}

/**
 * @param name the name to set
 */
public void setName(String name) {
	this.name = name;
}


}
