package roneditor.objectnetview.commands;

import ronmodel.ONPlace;
import ronmodel.ONTransition;


/**
 * Command class for a ONPlace/ONTransition connection.
 * Connects a ONPlace with a ONTransition via a ONArc.
 */
public class ConnectionONPlaceONTransCommand extends AbstractConnectionCommand {	
	private static final String ConnectionCommand_Description = 
		"ONArc: ONPlace connection command";

	/**
	 * Constructor.
	 */
	public ConnectionONPlaceONTransCommand() {
		super();
	}

	/**
	 * True if the command can be executed, false otherwise.
	 */
	public boolean canExecute() {
		if (source == null || target == null || onarc == null || source == target)
			return false;
		else return true;
	}

	/**
	 * Returns the command label.
	 */
	public String getLabel() {
		return ConnectionCommand_Description;
	}

	public void setSource(ONPlace source) {
		super.setSource(source);
	}

	public void setTarget(ONTransition target) {
		super.setTarget(target);
	}

	/**
	 * @return the source
	 */
	@Override
	public ONPlace getSource() {
		return (ONPlace)source;
	}

	/**
	 * @return the target
	 */
	@Override
	public ONTransition getTarget() {
		return (ONTransition)target;
	}

}
