package roneditor.objectnetview.commands;

import ronmodel.ONPlace;
import ronmodel.ONTransition;


/**
 * Command class for a ONTransition/ONPlace connection.
 * Connects a ONTransition with a ONPlace via a ONArc.
 */
public class ConnectionONTransONPlaceCommand extends AbstractConnectionCommand {	
	private static final String ConnectionCommand_Description = 
		"ONArc: ONTransition connection command";
	
	/**
	 * Constructor.
	 */
	public ConnectionONTransONPlaceCommand() {
		super();
	}

	/**
	 * True if the command can be executed, false otherwise.
	 */
	public boolean canExecute() {
		if (source == null || target == null || onarc == null || source == target)
			return false;
		else return true;
	}

	/**
	 * Returns the command label.
	 */
	public String getLabel() {
		return ConnectionCommand_Description;
	}
	
	public void setSource(ONTransition source) {
		super.setSource(source);
	}

	public void setTarget(ONPlace target) {
		super.setTarget(target);
	}

	/**
	 * @return the source
	 */
	@Override
	public ONTransition getSource() {
		return (ONTransition)source;
	}

	/**
	 * @return the target
	 */
	@Override
	public ONPlace getTarget() {
		return (ONPlace)target;
	}

}
