package roneditor.objectnetview.commands;

import roneditor.model.RONModelManager;
import ronmodel.RonmodelFactory;

public class CreateBendpointCommand extends AbstractBendpointCommand{
	
	public void execute(){
		
		RonmodelFactory mfc = RONModelManager.getFactory();
		
		bendPoint = mfc.createBendPoint();
		
		bendPoint.getH().add(new Integer(getFirstRelativeDimension().height));
		bendPoint.getW().add(new Integer(getFirstRelativeDimension().width));
		
		bendPoint.getH().add(new Integer(getSecondRelativeDimension().height));
		bendPoint.getW().add(new Integer(getSecondRelativeDimension().width));
		
		getONArc().getBendpoints().add(getIndex(), bendPoint);
		
	}
	
	public void undo(){
		getONArc().getBendpoints().remove(bendPoint);
	}
	
}
