package roneditor.objectnetview.commands;

import ronmodel.Codomain;
import ronmodel.LHS;
import ronmodel.Mapping;
import ronmodel.ONNode;


/**
 * Command for deleting a Mapping.
 */
public class DeleteMappingCommand 
		extends org.eclipse.gef.commands.Command {
	private static final String DeleteCommand_Label = "DeleteMappingCommand";
	private	 Mapping mapping;
	private ONNode source;
	private ONNode target;
	private Codomain codomain;
	private Integer mappingNr;

	/**
	 * 
	 */
	public DeleteMappingCommand() {
		super( DeleteCommand_Label );
	}

	/**
	 * Entry point for command execution.
	 */
	public void execute() {
		source = mapping.getSource();
		target = mapping.getTarget();
		codomain = mapping.getCodomain();
		mappingNr = mapping.getMappingNr();
		// Reihenfolge im Moment sehr wichtig
		// sobald Codomain gendert wird, wird Notifier geschickt, was dann updatet
		mapping.setCodomain(null);
		mapping.setMappingNr(-1);
		mapping.setSource(null);
		mapping.setTarget(null);
		
	
		((LHS)source.getObjectNet()).getRule().getMappingNumberList().removeMapping(mapping);
		
	}

	public void redo() {
		execute();
	}

	/**
	 * Undo command execution.
	 */
	public void undo() {
		// Reihenfolge im Moment sehr wichtig
		// sobald Codomain gendert wird, wird Notifier geschickt, was dann updatet
		mapping.setCodomain(codomain);
		mapping.setMappingNr(mappingNr);
		mapping.setSource(source);
		mapping.setTarget(target);
		((LHS)source.getObjectNet()).getRule().getMappingNumberList().setMappingNr(mappingNr,mapping);
	}

	/**
	 * @return the network
	 */
	public Codomain getCodomain() {
		return codomain;
	}

	/**
	 * @param codomain the codomain to set
	 */
	public void setCodomain(Codomain codomain) {
		this.codomain = codomain;
	}

	/**
	 * @return the mapping
	 */
	public Mapping getMapping() {
		return mapping;
	}

	/**
	 * @param mapping the mapping to set
	 */
	public void setMapping(Mapping mapping) {
		this.mapping = mapping;
	}

	/**
	 * @return the source
	 */
	public ONNode getSource() {
		return source;
	}

	/**
	 * @param source the source to set
	 */
	public void setSource(ONNode source) {
		this.source = source;
	}

	/**
	 * @return the target
	 */
	public ONNode getTarget() {
		return target;
	}

	/**
	 * @param target the target to set
	 */
	public void setTarget(ONNode target) {
		this.target = target;
	}

}
