package roneditor.objectnetview.commands;

import ronmodel.ONArc;
import ronmodel.ONNode;
import ronmodel.ObjectNet;


/**
 * Command for deleting a transition.
 */
public class DeleteONArcCommand 
		extends org.eclipse.gef.commands.Command {
	private static final String DeleteCommand_Label = "DeleteTransitionCommand";
	private	 ONArc onArc;
	private ONNode source;
	private ONNode target;
	private ObjectNet objectNet;

	/**
	 * 
	 */
	public DeleteONArcCommand() {
		super( DeleteCommand_Label );
	}

	/**
	 * Entry point for command execution.
	 */
	public void execute() {
		source = onArc.getSource();
		target = onArc.getTarget();
		objectNet = onArc.getObjectNet();
		onArc.setObjectNet(null);
		onArc.setSource(null);
		onArc.setTarget(null);
	}

	public void redo() {
		execute();
	}

	/**
	 * Undo command execution.
	 */
	public void undo() {
		onArc.setObjectNet(objectNet);
				
		onArc.setSource(source);
		onArc.setTarget(target);
				
	}

	/**
	 * @return the onArc
	 */
	public ONArc getONArc() {
		return onArc;
	}

	/**
	 * @param onArc the onArc to set
	 */
	public void setONArc(ONArc onArc) {
		this.onArc = onArc;
	}

	/**
	 * @return the source
	 */
	public ONNode getSource() {
		return source;
	}

	/**
	 * @return the target
	 */
	public ONNode getTarget() {
		return target;
	}


}
