package roneditor.objectnetview.commands;

import org.eclipse.gef.commands.Command;

import ronmodel.ONPlace;


/**
 * Edit Place properties.
 */
public class EditONPlaceCommand extends Command{
	private ONPlace onPlace;
	private String oldName = "";
	private String newName = "";
	private int oldTokens = 0;
	private int newTokens = 0;
	
	public EditONPlaceCommand(){
		setLabel("Edit Place");
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	public void execute() {
		oldName = onPlace.getName();
		oldTokens = onPlace.getTokens();
		onPlace.setName(newName);
		onPlace.setTokens(newTokens);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		onPlace.setName(oldName);
		onPlace.setTokens(oldTokens);
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	public void redo() {
		onPlace.setName(newName);
		onPlace.setTokens(newTokens);
	}

	/**
	 * @return the ONPlace
	 */
	public ONPlace getONPlace() {
		return onPlace;
	}

	/**
	 * @param ONPlace the ONPlace to set
	 */
	public void setONPlace(ONPlace newPlace) {
		this.onPlace = newPlace;
	}

	/**
	 * @return the newName
	 */
	public String getNewName() {
		return newName;
	}

	/**
	 * @return the newTokens
	 */
	public int getNewTokens() {
		return newTokens;
	}

	/**
	 * @param newName the newName to set
	 */
	public void setNewName(String newName) {
		this.newName = newName;
	}
	/**
	 * @param newTokens the newTokens to set
	 */
	public void setNewTokens(int newTokens) {
		if (newTokens<0) newTokens=oldTokens;
		this.newTokens = newTokens;
	}

}
