package roneditor.objectnetview.commands;

import org.eclipse.gef.commands.Command;

import ronmodel.ONTransition;


/**
 * Edit transition properties.
 */
public class EditONTransitionCommand extends Command{
	private ONTransition onTransition;
	private String oldName = "";
	private String newName = "";
	
	public EditONTransitionCommand(){
		setLabel("Edit Transition");
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	public void execute() {
		oldName = onTransition.getName();
		onTransition.setName(newName);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		onTransition.setName(oldName);
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	public void redo() {
		onTransition.setName(newName);
	}

	/**
	 * @return the ONTransition
	 */
	public ONTransition getONTransition() {
		return onTransition;
	}

	/**
	 * @param ONTransition the ONTransition to set
	 */
	public void setONTransition(ONTransition newTransition) {
		this.onTransition = newTransition;
	}

	/**
	 * @return the newName
	 */
	public String getNewName() {
		return newName;
	}

	/**
	 * @param newName the newName to set
	 */
	public void setNewName(String newName) {
		this.newName = newName;
	}

}
