package roneditor.objectnetview.commands;

import java.util.List;
import java.util.ListIterator;

import org.eclipse.gef.commands.Command;

import ronmodel.ONArc;
import ronmodel.ONPlace;
import ronmodel.ONTransition;

/**
 * Fire transition properties.
 */
public class FireONTransitionCommand extends Command{
	private ONTransition onTransition;
	
	public FireONTransitionCommand(){
		setLabel("Fire ONTransition");
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	public void execute() {		
		List incoming=onTransition.getIncoming();
		List outgoing=onTransition.getOutgoing();
		ONArc oa;
		ONPlace op;
		//take pre-tokens
		ListIterator li=incoming.listIterator();
		while (li.hasNext()){
			oa=(ONArc)li.next();
			op=(ONPlace)oa.getSource();
			op.setTokens(op.getTokens()-oa.getWeight());
		}
		//put post-tokens
		li=outgoing.listIterator();
		while (li.hasNext()){
			oa=(ONArc)li.next();
			op=(ONPlace)oa.getTarget();
			op.setTokens(op.getTokens()+oa.getWeight()); 
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		List incoming=onTransition.getIncoming();
		List outgoing=onTransition.getOutgoing();
		ONArc oa;
		ONPlace op;
		//put pre-tokens
		ListIterator li=incoming.listIterator();
		while (li.hasNext()){
			oa=(ONArc)li.next();
			op=(ONPlace)oa.getSource();
			op.setTokens(op.getTokens()+oa.getWeight()); 
		}
		//take post-tokens
		li=outgoing.listIterator();
		while (li.hasNext()){
			oa=(ONArc)li.next();
			op=(ONPlace)oa.getTarget();
			op.setTokens(op.getTokens()-oa.getWeight()); 
		}
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	public void redo() {
		execute();
	}

	/**
	 * @return the ONTransition
	 */
	public ONTransition getONTransition() {
		return onTransition;
	}

	/**
	 * @param ONTransition the ONTransition to set
	 */
	public void setONTransition(ONTransition newTransition) {
		this.onTransition = newTransition;
	}

}
