package roneditor.objectnetview.commands;

import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.commands.Command;

import ronmodel.ONArc;

/**
 * Command, welches das Verschieben des Labels eines ONArcs umsetzt.
 * 
 * @author Mario
 */
public class MoveONArcLabelCommand extends Command {

	ONArc onArc;

	Point delta;

	Point oldOffset;

	public MoveONArcLabelCommand(final ONArc onArc, final Point delta) {
		this.onArc = onArc;
		this.delta = delta;
	}

	/**
	 * Setzt den x und y-Wert im Modell entsprechend des delta neu
	 */
	@Override
	public void execute() {
		// alten x und y-Wert merken
		oldOffset = new Point(onArc.getWeightLabelX(), onArc.getWeightLabelY());
		// neue Werte berechen
		final Point newOffset = oldOffset.getCopy().translate(delta);
		// neue Werte setzen
		onArc.setWeightLabelX(newOffset.x);
		onArc.setWeightLabelY(newOffset.y);
	}

	@Override
	public void undo() {
		onArc.setWeightLabelX(oldOffset.x);
		onArc.setWeightLabelY(oldOffset.y);
	}
}