package roneditor.ronview;


import java.util.Map;

import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.gef.tools.CreationTool;

import roneditor.edit.parts.LabelEditPart;
import roneditor.ronview.commands.CreateHLPlaceCommand;
import roneditor.ronview.commands.CreateHLTransitionCommand;
import roneditor.ronview.edit.parts.HLPlaceEditPart;
import roneditor.ronview.edit.parts.HLTransitionEditPart;
import ronmodel.HLPlace;
import ronmodel.HLTransition;

public class RONCreationTool extends CreationTool {

	public RONCreationTool() {
		super();
	}
	
	public RONCreationTool(CreationFactory factory) {
		super(factory);
	}
	
	protected void executeCurrentCommand() {
		Command command = getCurrentCommand();
//		if ((command instanceof CreateHLTransitionCommand) && command.canExecute()){
//			if(!openNodeRoleDialog(command))
//				return;
//		}
//		else if ((command instanceof CreateHLPlaceCommand) && command.canExecute()){
//			if(!openNodeRoleDialog(command))
//				return;
//		}
		if (command instanceof CreateHLTransitionCommand) {
			((CreateHLTransitionCommand)command).setName("");
		} else if (command instanceof CreateHLPlaceCommand) {
			((CreateHLPlaceCommand)command).setName("");
		}  
		
		super.executeCurrentCommand();
		
		// direkt Edit kann erst nach dem Ausfhren des CreationCommands gemacht, werden.
		// Es wird der Name einfach nachtrglich umgendert vom Defaultwert.
		if ( command instanceof CreateHLTransitionCommand ) {
			HLTransition transition = (HLTransition)((CreateHLTransitionCommand)command).getHLNode();
			Map reg = getCurrentViewer().getEditPartRegistry();
			HLTransitionEditPart editPart = (HLTransitionEditPart)reg.get(transition);
			LabelEditPart labelEditPart = editPart.getLabelEditPart();
			Request request = new Request(RequestConstants.REQ_DIRECT_EDIT);
			labelEditPart.performRequest(request);
		} else if ( command instanceof CreateHLPlaceCommand ) {
			HLPlace place = (HLPlace)((CreateHLPlaceCommand)command).getHLPlace();
			Map reg = getCurrentViewer().getEditPartRegistry();
			HLPlaceEditPart editPart = (HLPlaceEditPart)reg.get(place);
			LabelEditPart labelEditPart = editPart.getLabelEditPart();
			Request request = new Request(RequestConstants.REQ_DIRECT_EDIT);
			labelEditPart.performRequest(request);
		}
		
	}
	
//	private boolean openNodeRoleDialog(Command command){
//		
//		if (command instanceof CreateHLTransitionCommand){
//			HLTransitionPropertiesDialog d = new HLTransitionPropertiesDialog(new Shell(), SWT.NULL);
//			d.setText("Create HLTransition");
//			d.open();
//			if(d.isCancelled()){
//				return false;
//			}
//			else{
//				((CreateHLTransitionCommand)command).setName(d.getName());
//				return true;
//			}
//		}
//		else if (command instanceof CreateHLPlaceCommand){
//			HLPlacePropertiesDialog d = new HLPlacePropertiesDialog(new Shell(), SWT.NULL);
//			d.setText("Create HLPlace");
//			d.open();
//			if(d.isCancelled()){
//				return false;
//			}
//			else{
//				((CreateHLPlaceCommand)command).setName(d.getName());
//				((CreateHLPlaceCommand)command).setTokens(d.getTokens());
//		        return true;
//			}
//		}
//		else return false;
//    }
	
}