package roneditor.ronview.commands;

import ronmodel.HLPlace;
import ronmodel.HLPlaceType;

/**
 * Command for adding a HLPlace to a RON. This is undoable.
 * 
 * @author Tony Modica
 */
public class CreateHLPlaceCommand extends AbstractCreateHLNodeCommand {

	private static final String CreateCommand_Label = "Create HLPlace";

	private HLPlaceType type;

	public CreateHLPlaceCommand() {
		super();
	}

	/**
	 * Executes the command by adding the HLPlace to the RON.
	 */
	@Override
	public void execute() {		
		if (type != null) {
			((HLPlace) hlNode).setType(type);
		}		
		super.execute();
	}

	/**
	 * Undoes the command by removing the HLPlace fromthe RON.
	 */
	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	@Override
	public void undo() {
		hlNode.setRon(null);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	@Override
	public void redo() {
		hlNode.setRon(ron);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.commands.Command#canExecute()
	 */
	@Override
	public boolean canExecute() {
		return hlNode != null && ron != null /* && type!=null */;
	}

	/**
	 * @param type
	 *            the type to set
	 */
	public void setType(final HLPlaceType type) {
		this.type = type;
	}

	public HLPlace getHLPlace() {
		return (HLPlace) hlNode;
	}

	public void setHLPlace(HLPlace hlNode) {
		this.hlNode = hlNode;
	}

}
