package roneditor.ronview.commands;

import ronmodel.HLTransition;




/**
 * Command for creating a place.
 */
public class CreateHLTransitionCommand 
extends AbstractCreateHLNodeCommand {

	/**
	 * Constructor.
	 *
	 */	
	public CreateHLTransitionCommand() {
		super();
	}
	
	/**
	 * Executes the command by adding the HLPlace to the RON.
	 */
	@Override
	public void execute() {
		hlNode.setName(name);
		hlNode.setRon(ron);
		hlNode.setLabelX(labelX);
		hlNode.setLabelY(labelY);
		hlNode.setX(x);
		hlNode.setY(y);
	}

	/**
	 * Undoes the command by removing the HLPlace fromthe RON.
	 */
	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	@Override
	public void undo() {
		hlNode.setRon(null);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	@Override
	public void redo() {
		hlNode.setRon(ron);
	}


	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.commands.Command#canExecute()
	 */
	@Override
	public boolean canExecute() {
		return hlNode!=null /*&& name != null*/ && ron!=null;
	}
	
	public HLTransition getHLTransition() {
		return (HLTransition)hlNode;
	}

	public void setHLTransition(HLTransition onNode) {
		this.hlNode = onNode;
	}
}
