package roneditor.ronview.commands;

import org.eclipse.gef.commands.Command;

import ronmodel.HLPlace;


/**
 * Edit Place properties.
 */
public class EditHLPlaceCommand extends Command{
	private HLPlace onPlace;
	private String oldName = "";
	private String newName = "";
	
	public EditHLPlaceCommand(){
		setLabel("Edit Place");
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	public void execute() {
		oldName = onPlace.getName();
		onPlace.setName(newName);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		onPlace.setName(oldName);
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	public void redo() {
		onPlace.setName(newName);
	}

	/**
	 * @return the HLPlace
	 */
	public HLPlace getHLPlace() {
		return onPlace;
	}

	/**
	 * @param HLPlace the HLPlace to set
	 */
	public void setHLPlace(HLPlace newPlace) {
		this.onPlace = newPlace;
	}

	/**
	 * @return the newName
	 */
	public String getNewName() {
		return newName;
	}


	/**
	 * @param newName the newName to set
	 */
	public void setNewName(String newName) {
		this.newName = newName;
	}

}
