package roneditor.ronview.commands;

import org.eclipse.gef.commands.Command;

import ronmodel.HLTransition;


/**
 * Edit transition properties.
 */
public class EditHLTransitionCommand extends Command{
	private HLTransition onTransition;
	private String oldName = "";
	private String newName = "";
	
	public EditHLTransitionCommand(){
		setLabel("Edit Transition");
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	public void execute() {
		oldName = onTransition.getName();
		onTransition.setName(newName);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		onTransition.setName(oldName);
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	public void redo() {
		onTransition.setName(newName);
	}

	/**
	 * @return the HLTransition
	 */
	public HLTransition getHLTransition() {
		return onTransition;
	}

	/**
	 * @param HLTransition the HLTransition to set
	 */
	public void setHLTransition(HLTransition newTransition) {
		this.onTransition = newTransition;
	}

	/**
	 * @return the newName
	 */
	public String getNewName() {
		return newName;
	}

	/**
	 * @param newName the newName to set
	 */
	public void setNewName(String newName) {
		this.newName = newName;
	}

}
