/**
 * 
 */
package roneditor.ronview.commands;

import org.eclipse.gef.commands.Command;

import ronmodel.HLPlace;
import ronmodel.Token;

/**
 * @author Mario
 *
 */
public class MoveHLTokenCommand extends Command {
	HLPlace oldHLPlace, newHLPlace;
	Token token;
	
	public MoveHLTokenCommand() {

		super();
	}


	/**
	 * Executes the command by adding the Token to the new HLPlace.
	 */
	@Override
	public void execute() {	
		oldHLPlace = token.getPlace();
		oldHLPlace.getTokens().remove(token);
		newHLPlace.getTokens().add(token);		
	}
	
	
	
	/**
	 * Undoes the command by removing the Token from the newHLPlace and adding it to the OldHLPlace.
	 */
	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	@Override
	public void undo() {
		newHLPlace.getTokens().remove(token);
		oldHLPlace.getTokens().add(token);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	@Override
	public void redo() {
		execute();
	}
	


	/**
	 * @param token the token to set
	 */
	public void setToken(Token token) {
		this.token = token;
	}


	/**
	 * @param newHLPlace the newHLPlace to set
	 */
	public void setNewHLPlace(HLPlace newHLPlace) {
		this.newHLPlace = newHLPlace;
	}
	
}
