package roneditor.ronview.edit.policies;

import org.eclipse.draw2d.Connection;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.BendpointEditPolicy;
import org.eclipse.gef.requests.BendpointRequest;

import roneditor.ronview.commands.AbstractHLBendpointCommand;
import roneditor.ronview.commands.CreateHLBendpointCommand;
import roneditor.ronview.commands.DeleteHLBendpointCommand;
import roneditor.ronview.commands.MoveHLBendpointCommand;
import ronmodel.HLArc;



public class ConnectionBendPointEditPolicy 
extends BendpointEditPolicy {
	
	protected  Command getCreateBendpointCommand(BendpointRequest request){
		AbstractHLBendpointCommand com = new CreateHLBendpointCommand();
		Point p = request.getLocation();
		Connection conn = getConnection();
		conn.translateToRelative(p);
		Point ref1 = getConnection().getSourceAnchor().getReferencePoint();
		Point ref2 = getConnection().getTargetAnchor().getReferencePoint();
		conn.translateToRelative(ref1);
		conn.translateToRelative(ref1);
		com.setRelativeDimensions(p.getDifference(ref1), p.getDifference(ref2));
		com.setHLArc((HLArc)request.getSource().getModel());
		com.setIndex(request.getIndex());
		return com;
		
		
	}
	
	protected  Command getDeleteBendpointCommand(BendpointRequest request){
		AbstractHLBendpointCommand com = new DeleteHLBendpointCommand();
		Point p = request.getLocation();
		com.setLocation(p);
		com.setHLArc((HLArc)request.getSource().getModel());
		com.setIndex(request.getIndex());
		return com;
		
		
		
	}
	
	protected  Command getMoveBendpointCommand(BendpointRequest request){
		MoveHLBendpointCommand com = new MoveHLBendpointCommand();
		Point p = request.getLocation();
		Connection conn = getConnection();
		
		conn.translateToRelative(p);
		
		com.setLocation(p);
		
		Point ref1 = getConnection().getSourceAnchor().getReferencePoint();
		Point ref2 = getConnection().getTargetAnchor().getReferencePoint();
        conn.translateToRelative(ref1);
        conn.translateToRelative(ref2);
        
        com.setRelativeDimensions(p.getDifference(ref1), p.getDifference(ref2));
        com.setHLArc((HLArc)request.getSource().getModel());
        com.setIndex(request.getIndex());
        
        return com;
		
		
	}
	
	protected Connection getConnection() {
		return (Connection)getHostFigure();
	}


}
