package roneditor.ronview.edit.policies;

import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.editpolicies.ConnectionEndpointEditPolicy;

/**
 * Edit policy for the endpoint (e.g. arrow) of a HLArc.
 */
public class HLArcEndpointEditPolicy 
	extends ConnectionEndpointEditPolicy {

	/**
	 * 
	 */
	public HLArcEndpointEditPolicy() {
		super();
	}

	protected void addSelectionHandles(){
		super.addSelectionHandles();
		getConnectionFigure().setLineWidth(2);
	}
	
	/*
	 * Returns the polyline connection figure
	 * with a line end arrow.
	 */
	protected PolylineConnection getConnectionFigure(){
		PolylineConnection con = (PolylineConnection)
			((GraphicalEditPart)getHost()).getFigure();
		
		return con;
	}
	
	protected void removeSelectionHandles(){
		super.removeSelectionHandles();
		getConnectionFigure().setLineWidth(1);
	}
}
