package roneditor.ronview.edit.utils;

import org.eclipse.core.runtime.Assert;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;

import roneditor.edit.parts.LabelEditPart;
import roneditor.ronview.edit.parts.HLArcEditPart;
import roneditor.ronview.edit.parts.HLPlaceEditPart;
import roneditor.ronview.edit.parts.HLTokenEditPart;
import roneditor.ronview.edit.parts.HLTransitionEditPart;
import roneditor.ronview.edit.parts.RONEditPart;
import ronmodel.HLArc;
import ronmodel.HLPlace;
import ronmodel.HLTransition;
import ronmodel.RON;
import ronmodel.Token;

/**
 * Factory class for edit parts. Here, the corresponding edit parts of a the
 * model elements are created.
 * 
 * @author Tony Modica
 */
public class RONViewEditPartFactory implements EditPartFactory {

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.EditPartFactory#createEditPart(org.eclipse.gef.EditPart,
	 *      java.lang.Object)
	 */
	public EditPart createEditPart(final EditPart context, final Object obj) {
		// HINT Passt diese Methode an Euer Modell und Eure EditParts an
		if(obj instanceof RON){
			RONEditPart p =  new RONEditPart((RON)obj);
			return p;
		} else if(obj instanceof HLTransition){
			 HLTransitionEditPart p = new HLTransitionEditPart((HLTransition)obj);
			 return p;
		} else if(obj instanceof HLPlace){
			HLPlaceEditPart p = new HLPlaceEditPart((HLPlace)obj);
		 	return p;
		} else if (obj instanceof HLArc){
			return new HLArcEditPart((HLArc)obj);
		} else if (context instanceof RONEditPart) {
			return new LabelEditPart(obj);
		} else if (obj instanceof Token){
			return new HLTokenEditPart((Token)obj); 
		}
		// Fehler melden
		Assert
				.isTrue(
						false,
						"RONViewEditPartFactory could not create an EditPart for the model element of type "
								+ obj.getClass());
		return null;
	}
}
