package roneditor.ruleview;

import org.eclipse.core.runtime.Assert;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.part.IPage;

import roneditor.AbstractPageBookView;
import ronmodel.ObjectNet;
import ronmodel.RonmodelPackage;
import ronmodel.Rule;

/**
 * 
 * @author Tony Modica
 */
public class RulePageBookView extends AbstractPageBookView {

	/*
	 * (non-Javadoc)
	 * 
	 * @see roneditor.objectnetview.AbstractPageBookView#getPageForModel(java.lang.Object)
	 */
	@Override
	protected IPage getPageForModel(final EObject model) {
		Assert
				.isTrue(
						model instanceof Rule,
						"The model that should be displayed in RulePageBookView is not an instance of the class Rule!");
		return new RulePage((Rule) model, (IEditorPart) getBootstrapPart());
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.emf.common.notify.Adapter#notifyChanged(org.eclipse.emf.common.notify.Notification)
	 */
	public void notifyChanged(final Notification notification) {
		final int featureId = notification.getFeatureID(RonmodelPackage.class);
		switch (featureId) {
		case RonmodelPackage.RULE__NAME:
			setPartName(calculatePartName());
			break;
		default:
			break;
		}
	}

	/**
	 * @return The name of the model {@link ObjectNet}.
	 */
	/*
	 * (non-Javadoc)
	 * 
	 * @see roneditor.objectnetview.AbstractPageBookView#calculatePartName()
	 */
	@Override
	protected String calculatePartName() {
		return ((Rule) getModel()).getName();
	}

}
