package roneditor.ruleview.actions;

import java.util.List;

import org.eclipse.emf.common.util.EList;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.ui.IWorkbenchPart;

import roneditor.objectnetview.commands.AbstractBendpointCommand;
import roneditor.objectnetview.commands.DeleteBendpointCommand;
import roneditor.objectnetview.edit.parts.ONArcEditPart;
import ronmodel.BendPoint;
import ronmodel.ONArc;

public class DeleteRuleBendPointAction extends SelectionAction {
	
	static public String ID = "Delete_BendPoint_Action";
	
	public DeleteRuleBendPointAction(IWorkbenchPart part){
		super(part);
		setDescription("Delete BendPoint Action");
		setText("Delete BendPoint");
	}
	
	public void run() {
		execute(getCommand());
	}
	
	protected boolean calculateEnabled() {
		return canPerformAction();
}
	public Command getCommand(){
		
		Object selection =
			((StructuredSelection) getSelection()).getFirstElement();
		if (selection instanceof ONArcEditPart){
			
		EList p = (EList) ((ONArcEditPart) selection).getONArc().getBendpoints();
		
		CompoundCommand compound = new CompoundCommand();
		for(Object ob:p){
			DeleteBendpointCommand bp = new DeleteBendpointCommand();
			compound.add(bp);
			bp.setONArc(((BendPoint) ob).getOnArc());
		}
		return compound;
				}
//		}
		return null;
		
	}
	
	/*
	 * Returns true if the action could be executed, false otherwise.
	 */
	private boolean canPerformAction() {
		if (getSelectedObjects().isEmpty())
			return false;
		List parts = getSelectedObjects();
		if (parts.size()==1){
			Object o = parts.get(0);
			if (!(o instanceof EditPart))
				return false;
			EditPart part = (EditPart) o;			
			if (part.getModel() instanceof ONArc)
				return true;
			else
				return false;
		}
		return false;
	}
	
	protected void init() {
		super.init();
		setId(ID);
	}

}
