/**
 * 
 */
package roneditor.ruleview.commands;

import org.eclipse.gef.commands.Command;

import roneditor.ruleview.RulePage;
import ronmodel.NAC;
import ronmodel.Rule;

/**
 * 
 * Command, welches eine leere NAC erzeugt.
 * 
 * @author Mario
 */
public class CreateNacCommand extends Command {
	private Rule rule;
	private RulePage rulePage;
	private NAC newNac;

	public CreateNacCommand() {
		setLabel("Create Nac");
	}

	/**
	 * 
	 */
	public void execute() {			
		newNac.setRule(rule);
		if (rule.getNacs().size() == 1) {
			rulePage.switchViewerVisibility(0);
		}
		// aktuelle Anzeige auf den neuen Nac legen
		rulePage.setViewersContents(0, newNac);
	}


	public void undo() {
		//remove new Nac
		newNac.setRule(null);
		if (rule.getNacs().size() == 0) {
			rulePage.switchViewerVisibility(0);
		}
		// aktuelle Anzeige auf den ersten Nac legen
		rulePage.setViewersContents(0, (NAC)rule.getNacs().get(0));
	}

	/*
	 *  reexecute
	 */
	public void redo() {
		execute();
	}

	public void setRule(Rule _rule) {
		this.rule = _rule;
	}

	/**
	 * @param newNac the newNac to set
	 */
	public void setNewNac(NAC newNac) {
		this.newNac = newNac;
	}

	/**
	 * @param rulePage the rulePage to set
	 */
	public void setRulePage(RulePage rulePage) {
		this.rulePage = rulePage;
	}
}
