/**
 * 
 */
package roneditor.ruleview.commands;

import org.eclipse.gef.commands.Command;

import roneditor.ruleview.RulePage;
import ronmodel.NAC;
import ronmodel.Rule;

/**
 * @author Mario
 *
 */
public class DeleteNacCommand extends Command {
	private Rule oldRule;
	private RulePage rulePage;
	private NAC deleteNac;

	public DeleteNacCommand() {
		setLabel("Delete Nac");
	}

	public void execute() {			
		//rule.getNacs().remove(deleteNac);
		oldRule = deleteNac.getRule();
		deleteNac.setRule(null);		
		// Wenn nach dem lschen noch Nacs vorhanden sind, dann auf den ersten die Sicht wechseln, 
		// ansonsten die Sicht verstecken
		if (oldRule.getNacs().size() > 0) {	
			final NAC newNACtoShow = (NAC) oldRule.getNacs().get(0);
	
			rulePage.setViewersContents(0, newNACtoShow);
		} else {
			rulePage.switchViewerVisibility(0);
		}
	}


	public void undo() {
		//remove new Nac
		//rule.getNacs().add(deleteNac);
		deleteNac.setRule(oldRule);		
		if (oldRule.getNacs().size()== 1) {
			rulePage.switchViewerVisibility(0);
		}
		// aktuelle Anzeige auf den gelschten ndern
		rulePage.setViewersContents(0, deleteNac);
	}

	/*
	 *  reexecute
	 */
	public void redo() {
		execute();
	}


	/**
	 * @param deleteNac the deleteNac to set
	 */
	public void setDeleteNac(NAC deleteNac) {
		this.deleteNac = deleteNac;
	}

	/**
	 * @param rulePage the rulePage to set
	 */
	public void setRulePage(RulePage rulePage) {
		this.rulePage = rulePage;
	}
}
