/**
 * <copyright>
 * </copyright>
 *
 * $Id: HLArc.java,v 1.5 2007/07/26 09:52:12 calistar Exp $
 */
package ronmodel;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>HL Arc</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link ronmodel.HLArc#getSource <em>Source</em>}</li>
 *   <li>{@link ronmodel.HLArc#getTarget <em>Target</em>}</li>
 *   <li>{@link ronmodel.HLArc#getRon <em>Ron</em>}</li>
 *   <li>{@link ronmodel.HLArc#getBendpoints <em>Bendpoints</em>}</li>
 *   <li>{@link ronmodel.HLArc#getAnchorNrS <em>Anchor Nr S</em>}</li>
 *   <li>{@link ronmodel.HLArc#getAnchorNrT <em>Anchor Nr T</em>}</li>
 * </ul>
 * </p>
 *
 * @see ronmodel.RonmodelPackage#getHLArc()
 * @model
 * @generated
 */
public interface HLArc extends EObject {
	/**
	 * Returns the value of the '<em><b>Source</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link ronmodel.HLNode#getOutgoing <em>Outgoing</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Source</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Source</em>' reference.
	 * @see #setSource(HLNode)
	 * @see ronmodel.RonmodelPackage#getHLArc_Source()
	 * @see ronmodel.HLNode#getOutgoing
	 * @model opposite="outgoing" required="true"
	 * @generated
	 */
	HLNode getSource();

	/**
	 * Sets the value of the '{@link ronmodel.HLArc#getSource <em>Source</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Source</em>' reference.
	 * @see #getSource()
	 * @generated
	 */
	void setSource(HLNode value);

	/**
	 * Returns the value of the '<em><b>Target</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link ronmodel.HLNode#getIncoming <em>Incoming</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Target</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Target</em>' reference.
	 * @see #setTarget(HLNode)
	 * @see ronmodel.RonmodelPackage#getHLArc_Target()
	 * @see ronmodel.HLNode#getIncoming
	 * @model opposite="incoming" required="true"
	 * @generated
	 */
	HLNode getTarget();

	/**
	 * Sets the value of the '{@link ronmodel.HLArc#getTarget <em>Target</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Target</em>' reference.
	 * @see #getTarget()
	 * @generated
	 */
	void setTarget(HLNode value);

	/**
	 * Returns the value of the '<em><b>Ron</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link ronmodel.RON#getArcs <em>Arcs</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Ron</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Ron</em>' container reference.
	 * @see #setRon(RON)
	 * @see ronmodel.RonmodelPackage#getHLArc_Ron()
	 * @see ronmodel.RON#getArcs
	 * @model opposite="arcs"
	 * @generated
	 */
	RON getRon();

	/**
	 * Sets the value of the '{@link ronmodel.HLArc#getRon <em>Ron</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Ron</em>' container reference.
	 * @see #getRon()
	 * @generated
	 */
	void setRon(RON value);

	/**
	 * Returns the value of the '<em><b>Bendpoints</b></em>' containment reference list.
	 * The list contents are of type {@link ronmodel.BendPoint}.
	 * It is bidirectional and its opposite is '{@link ronmodel.BendPoint#getHLArc <em>HL Arc</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Bendpoints</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Bendpoints</em>' containment reference list.
	 * @see ronmodel.RonmodelPackage#getHLArc_Bendpoints()
	 * @see ronmodel.BendPoint#getHLArc
	 * @model type="ronmodel.BendPoint" opposite="hLArc" containment="true"
	 * @generated
	 */
	EList getBendpoints();

	/**
	 * Returns the value of the '<em><b>Anchor Nr S</b></em>' attribute.
	 * The default value is <code>"-1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Anchor Nr S</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Anchor Nr S</em>' attribute.
	 * @see #setAnchorNrS(int)
	 * @see ronmodel.RonmodelPackage#getHLArc_AnchorNrS()
	 * @model default="-1"
	 * @generated
	 */
	int getAnchorNrS();

	/**
	 * Sets the value of the '{@link ronmodel.HLArc#getAnchorNrS <em>Anchor Nr S</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Anchor Nr S</em>' attribute.
	 * @see #getAnchorNrS()
	 * @generated
	 */
	void setAnchorNrS(int value);

	/**
	 * Returns the value of the '<em><b>Anchor Nr T</b></em>' attribute.
	 * The default value is <code>"-1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Anchor Nr T</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Anchor Nr T</em>' attribute.
	 * @see #setAnchorNrT(int)
	 * @see ronmodel.RonmodelPackage#getHLArc_AnchorNrT()
	 * @model default="-1"
	 * @generated
	 */
	int getAnchorNrT();

	/**
	 * Sets the value of the '{@link ronmodel.HLArc#getAnchorNrT <em>Anchor Nr T</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Anchor Nr T</em>' attribute.
	 * @see #getAnchorNrT()
	 * @generated
	 */
	void setAnchorNrT(int value);

} // HLArc